# -*- coding: gbk -*-
import json
import os
import re

from .tool import *


def format_wxml(wxml_content):
    """ʽ WXML ݣӺʵǩ"""
    indent_level = 0
    formatted_content = []

    # ͨзָ WXML 
    lines = wxml_content.splitlines()

    for line in lines:
        # ɾÿеǰո
        line = line.strip()

        # 
        if not line:
            continue

        # Ǳպϱǩ</tag>
        if re.fullmatch(r'</[^>]+>', line):
            indent_level -= 1

        # 
        formatted_content.append('\t' * indent_level + line)

        # ǿǩ<tag>  <tag />
        if re.fullmatch(r'<[^/][^>]*[^/]>', line):  # ͨʼǩ
            indent_level += 1

    return '\n'.join(formatted_content)


def format_wxss(content):
    """ʽ WXSS (CSS) ļ"""
    from cssbeautifier import beautify
    return beautify(content, {"indent_size": 2})  # 2 ո


def format_js(content):
    """ʽ JavaScript """
    import jsbeautifier
    return jsbeautifier.beautify(content, {"indent_size": 2})  # 2 ո


def format_json(content):
    """ʽ JSON ļ"""
    try:
        data = json.loads(content)  #  JSON
        return json.dumps(data, indent=2, ensure_ascii=False)  # 2 ո
    except json.JSONDecodeError:
        return content  # ʧܣԭ


def format_file(file_path):
    """ļ͸ʽļ"""
    _, ext = os.path.splitext(file_path)
    with open(file_path, "r", encoding=Encoding) as f:
        content = f.read()

    if ext == ".wxml":
        formatted_content = format_wxml(content)
    elif ext == ".wxss":
        formatted_content = format_wxss(content)
    elif ext == ".js":
        formatted_content = format_js(content)
    elif ext == ".json":
        formatted_content = format_json(content)
    else:
        print(f" {file_path}ֵ֧ĸʽ")
        return

    with open(file_path, "w", encoding=Encoding) as f:
        f.write(formatted_content)
    print(f"ʽ: {file_path}")


def format_directory(directory):
    """ʽָĿ¼µ WXMLWXSSJSJSON ļ"""
    for root, _, files in os.walk(directory):
        for file in files:
            if file.endswith((".wxml", ".wxss", ".js", ".json")):
                format_file(os.path.join(root, file))
