# -*- coding: gbk -*-
import logging

from antlr4 import *
from antlr4.error.ErrorListener import ErrorListener

from .wxclLexer import wxclLexer
from .wxclListener import wxclListener
from .wxclParser import wxclParser


# ͨôڴʷ﷨
class MyErrorListener(ErrorListener):
    def syntaxError(self, recognizer, offendingSymbol, line, column, msg, e):
        error_message = f"Error at line {line}, column {column}: {msg}"
        logging.error(error_message)  # ¼־
        raise RuntimeError(error_message)  # ֱ׳쳣ֹ


def translateWxcl(code: str) -> bool:
    """
     wxcl ַ

    :
        code (str): Ҫ wxcl 

    :
        bool: ɹ True򷵻 False
    """

    # ־
    logging.basicConfig(filename='translation_errors.log',
                        level=logging.ERROR,
                        format='%(asctime)s - %(levelname)s - %(message)s')

    try:
        # ʹ ANTLR  InputStream ַ
        input_stream = InputStream(code)

        # ʷ
        lexer = wxclLexer(input_stream)
        lexer.removeErrorListeners()  # ƳĬϵĴ
        lexer.addErrorListener(MyErrorListener())  # Զ

        stream = CommonTokenStream(lexer)

        # ﷨
        parser = wxclParser(stream)
        parser.removeErrorListeners()  # ƳĬϵĴ
        parser.addErrorListener(MyErrorListener())  # Զ

        # ʼ
        tree = parser.project()  #  'project' Ŀʼ

        # ﷨
        walker = ParseTreeWalker()
        listener = wxclListener()
        walker.walk(listener, tree)
        return True  # ɹ True

    except (RuntimeError, Exception) as e:
        print(f"{e}")
        return False
